
const fs = require("fs")
const botconfig = require("./botconfig.json")
const Discord = require("discord.js")
const bot = new Discord.Client({fetchAllMembers: true})
let talkedRecently = new Set();
let swears = []
let nonExemptSpam = []
let nonExemptSwear = []
let cooldown = 2500
let now = Math.floor(Date.now());





bot.commands = new Discord.Collection()
let prefix = botconfig.prefix

bot.on("ready", async () => {
	console.log(`${bot.user.username} is online!`)
	
})

bot.on("message", async message => {

	if(message == "!help") {
		let helpEmbed = new Discord.RichEmbed()
		.setTitle("**Help**")
		.setColor("#00c43e")
		.addField("!buildSpam", "Initializes Spam module")
		.addField("!buildSwear", "Initializes Swear module")
		.addField("!setCooldown", "Sets the cooldown between messages")
		.addField("!antispam toggle", "Toggles the Spam module")
		.addField("!antiswear toggle", "Initializes Swear module")
		.addField("!antiswear add", "Blacklists a word")
		.addField("!antiswear remove", "UnBlacklists a word")
		.addField("!antiswear list", "Lists all blacklisted words")

		message.channel.send(helpEmbed)

	}

	if(message == "!buildSpam") {
		if(!message.member.hasPermission("ADMINISTRATOR")) return message.channel.send("You do not have the permissions required to run this command.")
		message.channel.send('Building...').then(async (message) => {
			let number = 1
			let channelEmbed = new Discord.RichEmbed()
				.setTitle("AntiSpam")
				.setColor("00c43e")
				.setFooter("Channels Moderated By The AntiSpam")
	
			let gChannels = message.guild.channels
			await gChannels.forEach(function(gChannel) {
	
				let cName = gChannel.name
				if(gChannel.type == "text") {
					nonExemptSpam.push(cName)
					channelEmbed.addField(number, cName)
					number++
				}
			}) 
	
			await message.edit(channelEmbed)
		})

	}

	if(message == "!buildSwear") {
		if(!message.member.hasPermission("ADMINISTRATOR")) return message.channel.send("You do not have the permissions required to run this command.")
		message.channel.send('Building...').then(async (message) => {
			let number = 1
			let channelEmbed = new Discord.RichEmbed()
				.setTitle("AntiSwear")
				.setColor("#00c43e")
				.setFooter("Channels Moderated By The AntiSwear")
	
			let gChannels = message.guild.channels
			await gChannels.forEach(function(gChannel) {
	
				let cName = gChannel.name
				if(gChannel.type == "text") {
					nonExemptSwear.push(cName)
					channelEmbed.addField(number, cName)
					number++
				}
			}) 
	
			await message.edit(channelEmbed)
		})

	}

	if(message.content.startsWith("!setCooldown")) {
		messageArray = message.content.split(" ")
		let cmd = messageArray[0]
		let args = messageArray.slice(1)
		let cooldown = args[0]
		message.channel.send(`Set antispam cooldown to ${cooldown} second(s).\nNote that this does not affect commands.`)
	}

	if(message == "!antispam toggle") {
		if(!message.member.hasPermission("ADMINISTRATOR")) return message.channel.send("You do not have the permissions required to run this command.")
		if(nonExemptSpam.indexOf(message.channel.name) == -1) {
			await nonExemptSpam.push(message.channel.name)
			message.channel.send("This channel will now be moderated by the antispam.")
			return;
		}

		message.channel.send("This channel will now be ignored by the antispam.")
			let occurrence = nonExemptSpam.indexOf(message.channel.name)
			await nonExemptSpam.splice(occurrence, 1)
			return;
	}

	if(message.content.startsWith('!antiswear add')) {
		messageArray = message.content.split(" ")
		let cmd = messageArray[0]
		let args = messageArray.slice(2)
		if(!message.member.hasPermission("ADMINISTRATOR")) return message.channel.send("You do not have the permissions required to run this command.")
		if(!swears.indexOf(message.channel.name) == -1) return message.channel.send("That word is already blacklisted.")
		swears.push(args[0])
		message.channel.send("This word will now be blacklisted.")
		return;
	
	}

	if(message.content.startsWith("!antiswear remove")) {
		if(!message.member.hasPermission("ADMINISTRATOR")) return message.channel.send("You do not have the permissions required to run this command.")
		messageArray = message.content.split(" ")
		let cmd = messageArray[0]
		let args = messageArray.slice(2)
		if(swears.indexOf(args[0]) == -1) {
			message.channel.send("This word is not blacklisted!")
			return;
		}

		message.channel.send("This word will now be allowed.")
			let occurrence = swears.indexOf(args[0])
			await swears.splice(occurrence, 1)
			return;
	}

	if(message == "!antiswear toggle") {
		if(!message.member.hasPermission("ADMINISTRATOR")) return message.channel.send("You do not have the permissions required to run this command.")
		if(nonExemptSwear.indexOf(message.channel.name) == -1) {
			await nonExemptSwear.push(message.channel.name)
			message.channel.send("This channel will now be moderated by the antiswear.")
			return;
		}

		message.channel.send("This channel will now be ignored by the antiswear.")
			let occurrence = nonExemptSwear.indexOf(message.channel.name)
			await nonExemptSwear.splice(occurrence, 1)
			return;
	}	

	if(message == "!antiswear list") {
		if(!message.member.hasPermission("ADMINISTRATOR")) return message.channel.send("You do not have the permissions required to run this command.")
		let count = 1
		let swearEmbed = new Discord.RichEmbed()
		.setTitle("AntiSwear")
		.setColor("00c43e")
		.setFooter("Words Blacklisted By The AntiSwear")

		for(x = 0; x < swears.length; x++) {
			
			swearEmbed.addField(count, swears[x])
			count++
		}

		message.author.send(swearEmbed)
	}


})

bot.on("message", async message => {
	if(message.author.id == "426254458826129408") return

	for(x = 0; x < swears.length; x++) {
		for(i = 0; i < nonExemptSwear.length; i++) {
			if(nonExemptSwear[i] == message.channel.name) {
				if (message.content.startsWith(prefix)) return;
		
				if(message.content.includes(swears[x]) == true) {
					await message.delete()
					message.channel.send("Hey! You can't say that")
				}
			}
		}

		
	}

	for(x = 0; x < nonExemptSpam.length; x++) {
		if (message.content.startsWith(prefix)) return;
		if(nonExemptSpam[x] == message.channel.name) {
			if (talkedRecently.has(message.author.id)) {
				await message.delete()
			}
				
			talkedRecently.add(message.author.id)
		
			setTimeout(() => {
			talkedRecently.delete(message.author.id)
			}, cooldown);
		}
	}

	let time = Math.floor(Date.now());
	if(time == now + 3600000) {
		message.channel.send(`I am watching you.\n@everyone Discord Server Link: https://discord.gg/rQUrv4U`)
		let now = Math.floor(Date.now());
	}
	if (!message.content.startsWith(prefix)) return


	let messageArray = message.content.split(" ")
	let cmd = messageArray[0]
	let args = messageArray.slice(1)




})





bot.login(botconfig.token)
